#!/usr/bin/perl -w
use strict;
use sigtrap;

# Copyright Philipp L. Wesche 2003
# Released under the terms of the General Public License (GPL)
# The GPL can be found at
# http://www.gnu.org/copyleft

open(IN, $ARGV[0]) || die "Opening file failed.\n";
chomp (my @lines = <IN>);
close IN;

my $line_array_length = @lines;

my $ident = 0;

my $linenum = 0;

&place_repetitives;

&generations(0, 0, $ident);

sub generations {
	# make it more readable
	my $depth = $_[0];
	my $startline = $_[1];

	my $filenum = $_[2];
	++$ident;

	my @links_thislevel;
	my @urls_thislevel;

	my $aktuell = 0;

	while (defined($lines[$linenum])) {
		my @chars = split (//, $lines[$linenum]);
		unless (defined($chars[0])) {
			last;
		}
		if ($depth > 0) {
			unless ($lines[$linenum] =~ /^ {$depth}/) {
				last;
			}
		}
		if ($chars[$depth] eq " ") {
			$urls_thislevel[$aktuell] = $ident;
			&generations( ($depth + 1), $linenum, $ident);
		} else {
			my $quickline = $lines[$linenum];
			$quickline =~ s/^ +//;
			$quickline =~ s/_/ /g;
			push (@links_thislevel, $quickline);
			++$linenum;
			++$aktuell;
		}
	}

	open (OUT, ">$filenum.html");
	print OUT '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"><html><head><meta http-equiv="content-type" content="text/html; charset=ISO-8859-1"><title>Mugar user interface</title><style type="text/css"><!-- p {font-size:14pt; font-weight:bold; margin:30px;}//--></style></head><body>';
	for (my $indaxe = 0; $indaxe < @links_thislevel; ++$indaxe) {
		if (defined($urls_thislevel[$indaxe + 1])) {
			print OUT '<p><a href="'.$urls_thislevel[$indaxe + 1].'.html">'.$links_thislevel[$indaxe].'</a></p>';
		} else {
			print OUT '<p>'.$links_thislevel[$indaxe].'</p>';
		}
	}
	print OUT '</body></html>';
	close OUT;
	++$ident;
}

sub place_repetitives {

	my $repet_start_line;

	for (my $i = 0; $i < $line_array_length; ++$i) {
		if ($lines[$i] =~ /repetitive elements/) {
			$repet_start_line = $i;
			last;
		}
	}

	my @repetlines = @lines[$repet_start_line..(@lines - 1)];

	for (my $k = 0; $k < @lines; ++$k) {
		my $liny = $lines[$k];
		if ($liny =~ /^ +\(\(/) {
			my $depth;
			my @splitliny = split (//, $liny);
			for (my $ei = 0; ; ++$ei) {
				if ($splitliny[$ei] ne " ") {
					$depth = $ei;
					last;
				}
			}
			$liny =~ s/^ +//;
			$liny =~ s/^\(//;
			$liny =~ s/\)$//;

			my @list;

			for (my $sig = 0; $sig < @repetlines; ++$sig) {
				if ($liny eq $repetlines[$sig]) {
					for (my $hi = $sig + 1; ; ++$hi) {
						if ($repetlines[$hi] ne "") {
							push (@list, $repetlines[$hi]);
						} else {
							last;
						}
					}
					for (my $mama = 0; $mama < @list; ++$mama) {
						for (my $kind = 0; $kind < ($depth - 1); ++$kind) {
							$list[$mama] = " ".$list[$mama];
						}
					}
				}
			}

			splice (@lines, $k, 1, @list) && print "that worked @list\n";
		}
	}
}
